// Output generated from file: D:/fractal/Fragmentarium/Output/tests/SamTiba/QuatJulPoly-9_Files/QuatJulPoly-9.frag
// Created: Wed Jun 14 15:37:02 2017
// Output generated from file: D:/fractal/Fragmentarium/Output/tests/SamTiba/QuatJulPoly.frag
// Created: Wed Jun 14 14:33:19 2017
#info Quaternion Juliasets of functions

#define providesInside

#define providesColor

#include "Brute-Raytracer.frag"
#group QuaternionJulia
//#define IterationsBetweenRedraws 5

// Number of fractal iterations.
uniform int Iterations;  slider[0,10,100]

// Highest Power of the Numerator
// uniform float PowerNum; slider[1,3,10]

// Highest Power of the Denumerator
// uniform float PowerDen; slider[1,2,10]

// Divergence Radius for inside
uniform float Bailout; slider[0,1,6]

// Distance between points to check with
uniform float CheckDist; slider[0,0.1,1]

uniform vec3 RotVector; slider[(0,0,0),(1,1,1),(1,1,1)]
uniform float RotAngle; slider[0.00,0,180]

// 3 sliders to change multipliers of the polynoms
uniform vec4 CNum0; slider[(-2,-2,-2,-2),(0,0,0,0),(2,2,2,2)]
uniform vec4 CNum1; slider[(-2,-2,-2,-2),(0,0,0,0),(2,2,2,2)]
uniform vec4 CNum2; slider[(-2,-2,-2,-2),(0,0,0,0),(2,2,2,2)]

// i will work on that later
vec3 color(vec3 p) {
	return abs(vec3(p));
}

vec4 power(vec4 z, int a) {
	vec4 znew = vec4(z);
	// a^3 = (a^2) * a = a*a*a
	for (int ia = 1; ia < a; ia++) {
		znew = vec4(znew.x*z.x - znew.y*z.y - znew.z*z.z - znew.w*z.w, znew.y*z.x + znew.x*z.y + znew.z*z.w - znew.w*z.z, znew.z*z.x + znew.x * z.z - znew.x*z.w + znew.w*z.x, znew.w*z.x + znew.x*z.w + znew.y*z.z - znew.z*z.y);
	}
	return znew;
}

// computation of the step z = f(z)
vec4 formula(vec4 z) {
	// polynom of grade 2, minimal working example for normal Quaternion Julia sets
	vec4 zout  = CNum0 + CNum1 * z + CNum2 * power(z,2);
	return zout;
}

bool inside(vec3 pos) {
	// initalize point and 3 neighboured points
	vec4 z= vec4(pos,0.0);
	vec4 zr = z - vec4(CheckDist,0,0,0);
	vec4 zi = z - vec4(0,CheckDist,0,0);
	vec4 zj = z - vec4(0,0,CheckDist,0);

	// degree to 1-i-j-k-surface on the riemann-sphere (here 5-dimensional riemann-sphere)
	float degree;
	float degreer;
	float degreei;
	float degreej;

	// difference between the degrees as bailout-condition
	float arc;

	int i=0;
	while((arc < Bailout) && (i < Iterations)) {
	// while((i < Iterations)) {
		z = formula(z);
		zr = formula(zr);
		zi = formula(zi);
		zj = formula(zj);

		// projection to the riemann-sphere
		degree = asin((z.x * z.x + z.y * z.y + z.z * z.z + z.w * z.w - 1)/(z.x * z.x + z.y * z.y + z.z * z.z + z.w * z.w + 1));
		degreer = asin((zr.x * zr.x + zr.y * zr.y + zr.z * zr.z + zr.w * zr.w - 1)/(zr.x * zr.x + zr.y * zr.y + zr.z * zr.z + zr.w * zr.w + 1));
		degreei = asin((zi.x * zi.x + zi.y * zi.y + zi.z * zi.z + zi.w * zi.w - 1)/(zi.x * zi.x + zi.y * zi.y + zi.z * zi.z + zi.w * zi.w + 1));
		degreej = asin((zj.x * zj.x + zj.y * zj.y + zj.z * zj.z + zj.w * zj.w - 1)/(zj.x * zj.x + zj.y * zj.y + zj.z * zj.z + zj.w * zj.w + 1));

		// comparison between neighboured points to determine continous behaviour of the iterated function on this point
		arc = max(abs(degree-degreer),max(abs(degree-degreei),abs(degree-degreej)));
		i++;
	}
	return (arc > Bailout);
}






#preset Default
FOV = 0.814864
Eye = 1.906291,-18.0748,28.07166
Target = 1.917177,-17.581,27.20214
Up = 0.9670545,-0.2278266,-0.1172759
EquiRectangular = false
AutoFocus = false
Gamma = 1
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
SpecularExp = 1
SpotLight = 1,0.9215686,0.7882353,0.192623
SpotLightDir = 0.1,0.1
CamLight = 0.827451,0.9882353,1,0.0559727
CamLightMin = 0
Fog = 0
BaseColor = 0.6705882,0.6705882,0.6705882
OrbitStrength = 0.5579661
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.6,0.6,0.45
GradientBackground = 0.3
CycleColors = false
Cycles = 1.1
Iterations = 5
Bailout = 0.2367893
CheckDist = 0.3168919
RotVector = 1,1,1
RotAngle = 0
CNum0 = 0.2081934,0.0550705,0.065816,0
CNum1 = -0.2619208,-0.197448,-0.3801209,-0.116857
CNum2 = 0.0335796,0.1571525,0.175957,-0.014775
ToneMapping = 4
NormalScale = 0.3744044
AOScale = 1.516476
Glow = 0.1130319
AOStrength = 0.6
Samples = 99
Stratify = true
DebugInside = false
CentralDifferences = true
SampleNeighbors = true
Near = 0
Far = 36.98466
DepthToAlpha = false
DebugNormals = false
Specular = 1.552878
#endpreset

